//


#include "direccional.h"
#include "resource.h"
#include <shellapi.h>
#include <malloc.h>

TCHAR szDescription[] = TEXT("direccional v0.0a");
TCHAR szName[]        = TEXT("direccional");




const int cyb = int(0.114*219/255*65536+0.5);
const int cyg = int(0.587*219/255*65536+0.5);
const int cyr = int(0.299*219/255*65536+0.5);


#define VERSION         0x00000000      // 0.0




/* Direccional algorithm created by Abraham Macas Paredes
   more information on http://www.amacias.tk
*/
/*================================================================================*/
static unsigned int **Sections=NULL;
static unsigned int nsections=0;
static unsigned Actual[16][16];
static unsigned *Past;
static unsigned char* LastFrame;
static unsigned char* yuy2_buffer;
static unsigned char* yuy2_buffer_old[2];
static bool enable_sections=false;
unsigned char *Section[8];


static inline void sub_filter(unsigned char *src, unsigned char *dst, int len);
static inline void sub_filter_inv(unsigned char *src, unsigned char *dst, int len);
static inline int Compress(unsigned char *src, unsigned char *dst, int width, int height);
static inline void Decompress(unsigned char *src,unsigned char *dst,int len, int width, int height);
void Msg(const char fmt[], ...);

/*================================================================================*/
static inline int compress(unsigned char *src, unsigned char *dst, int width, int height)
{
	int len, len2;

/*
In order to know if I allocate memory and not free it during the Compress call
I have used this:
 
http://msdn.microsoft.com/library/en-us/vcce/htm/evc_guide11_46.asp?frame=true#_evc_detecting_a_memory_leak 

And for problems when compiling:
 Project | Settings | General| Use MFC in a Shared DLL
http://support.microsoft.com/default.aspx?scid=kb;en-us;q148652

*/
/*
#if defined(_DEBUG)
	CMemoryState oldMemState, newMemState, diffMemState;
    oldMemState.Checkpoint();
#endif
*/
	sub_filter(src,yuy2_buffer_old[0],width*height*3);

	len2=Compress(yuy2_buffer_old[0],yuy2_buffer_old[1],width,height);
/*
#if defined(_DEBUG)
	newMemState.Checkpoint();
    if( diffMemState.Difference( oldMemState, newMemState ) )
    {
        Msg( "Memory leaked!\n" );
    }
	else
        Msg( "NO Memory leaked!\n" );
#endif
*/
    len=Compress(src,dst+1,width,height);
    if(len==-1)
		len=width*height*3;
    if(len2==-1)
		len2=width*height*3;
	
	if(len>len2)
	{
	  memcpy(dst+1,yuy2_buffer_old[1],len2);
	  len=len2+1;
	  *dst=1;
	}
	else
	{
	  *dst=0;
	  len++;
	}


	return len;
}
static inline void decompress(unsigned char *src,unsigned char *dst,int len, int width, int height)
{
	if(*src)
	{
	 Decompress(src+1,yuy2_buffer_old[0],len-1,width,height);
	 sub_filter_inv(yuy2_buffer_old[0],dst,width*height*3);
	}
	else
	{
	 Decompress(src+1,dst,len-1,width,height);
	}
}

/*================================================================================*/
static inline void sub_filter(unsigned char *src, unsigned char *dst, int len)
{
 int i,l;
 l=len-3;

 for(i=0;i<l;i++)
 {
  *dst=*src - *(src+3);
  dst++;
  src++;
 }/*for*/

 for(i=0;i<3;i++)
 {
  *dst=*src;
  dst++;
  src++;
 }/*for*/


}/*sub_filter*/
/*================================================================================*/
static inline void sub_filter_inv(unsigned char *src, unsigned char *dst, int len)
{
 int i,l;
 l=len-3;
 dst=dst+len-1;
 src=src+len-1;

 for(i=0;i<3;i++)
 {
  *dst=*src;
  dst--;
  src--;
 }/*for*/

 for(i=0;i<l;i++)
 {
  *dst=*src + *(dst+3);
  dst--;
  src--;
 }/*for*/



}/*sub_filter*/
/*================================================================================*/
/* EQUALITY FUNCTION */
static inline int Equals(unsigned int *One, unsigned int *Two)
{
 int e=1;
 int x;

 for(x=0;x<256;x++)
  if(One[x]!=Two[x])
   e=0;

 return e;
}/*Equals*/



/*================================================================================*/
static inline void bubble(unsigned char *Numbers, int Begin, int End)
{
 int pos,ele,aux;

 for(pos=Begin;pos<End;pos++)
  for(ele=End;ele>pos;ele--)
   if(Numbers[ele]<Numbers[ele-1])
   {
    aux=Numbers[ele];
    Numbers[ele]=Numbers[ele-1];
    Numbers[ele-1]=aux;
   }/*if*/
}/*bubble*/

/*================================================================================*/
/* Basic compression function of one 16x16 block that can be compressed */
/* The source 16x16 block is in Actual variable*/
static inline int Direccional(unsigned char *dst)
{
 int x,y,x2,y2;
 unsigned Col;
 unsigned char *dest, *number;
 dest=dst;


    for(y=0;y<16;y++)
     for(x=0;x<16;x++)
     {
      if(Actual[x][y]!=0)
      {
       *dest=(Actual[x][y]>>16) & 0xFF;
       dest++;
       *dest=(Actual[x][y]>>8) & 0xFF;
       dest++;
       *dest=Actual[x][y] & 0xFF;
       dest++;
       *dest=1;
       number=dest;
       dest++;
       *dest= (x << 4) | y;
       dest++;
       Col=Actual[x][y];
       Actual[x][y]=0;
       for(y2=0;y2<16;y2++)
        for(x2=0;x2<16;x2++)
         if(Col==Actual[x2][y2])
         {
          *dest= x2 << 4 | y2;
          dest++;
          Actual[x2][y2]=0;
          *number=*number+1;
         }/*if*/

       if(*number==0)
       {
        /* If 256 colors */
        dest=number+1;
       }/*if*/
       else
       if(*number>=224)
       {
        int n,m;
        unsigned char *source;


        source=number+1;
        bubble(source,0,*number-1);

        m=*source;
        for(n=0;n<*source;n++)
        {
         *dest=(char) n;
         dest++;
        }/*for*/
        source++;

        for(n=m+1;n<256;n++)
         if(n!=*source)
         {
          *dest=(char) n;
          dest++;
         }/*if*/
         else
         {
          source++;
         }/*else*/

        source=dest-256+(*number);
        dest=number+1;
        for(n=0;n<256-*number;n++)
        {
         *dest=*source;
         dest++;
         source++;
        }/*for*/
        
       }/*if*/
       else
       if(*number>32)
       {
        /* Set the bitmap*/
        int n,m,num;
        unsigned char *source;


        source=number+1;
        bubble(source,0,*number-1);
        for(n=0;n<32;n++)
         *(dest+n)=0;

        m=0;
        num=*number;

        for(n=0;n<256;n++)
         if(n==*source)
         {
          source++;
          (*dest)<<=1;
          (*dest)|=1;
          num--;
          if(num==0)
           source--;
          m++;
          if(m==8)
          {
           dest++;
           m=0;
          }/*if*/
         }/*if*/
         else
         {
          *dest<<=1;
          *dest|=0;
          m++;
          if(m==8)
          {
           dest++;
           m=0;
          }/*if*/
         }/*else*/
        if(num!=0)
         Msg("Error codifing %i positons: Error: %i\n", *number, num);

        source=dest-32;
        dest=number+1;

        for(n=0;n<32;n++)
        {
         *dest=*source;
         dest++;
         source++;
        }/*for*/
       }/*if*/
      }/*if*/
     }/*for*/



 return dest-dst;
}/*Direccional*/
/*================================================================================*/
/* Basic decompression function of one 16x16 block that can be compressed */
/* The dest 16x16 block is in Past variable and must be allocated*/
static inline int DireccionalInv(unsigned char *src)
{
 int x,y,Total;
 unsigned k;
 unsigned Colour;
 unsigned number;
 unsigned char *sour;

 sour=src;
 Total=256; /* 256 colours */

    /* Fill with zeroes */
    for(x=0;x<16;x++)
     for(y=0;y<16;y++)
      Past[x + (y<<4)]=0;

   /* Take one section */
   Colour=*src;
   Colour<<=8;
   src++;
   Colour|=*src;
   Colour<<=8;
   src++;
   Colour|=*src;
   src++;
   number=*src;
   src++;


    /* Fill with colour*/
    if(number==0x00)
    {
     /* Fill the 256 elements with colour */
     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
       Past[x + (y<<4)]=Colour;
     Colour=0;
     src++;
     Total=0;
    }/*if*/
    else
    if(number==0xFF)
    {
     /* Fill the 255 elements with colour */
     int n;
     n=*src;

     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
       if((x + (y<<4)) != n)
        Past[x + (y<<4)]=Colour;

     src++;
     Colour=*src;
     Colour<<=8;
     src++;
     Colour|=*src;
     Colour<<=8;
     src++;
     Colour|=*src;
     src++;
     number=*src;
     src++;

     Total=0;
    }/*if*/


    while(Colour!=0 && Total>0)
    {
     if(number<=32)
     {
      for(k=0;k<number;k++)
      {
       x=*src;
       y=x & 0xF;
       x=x>>4;
       Past[x + (y<<4)]=Colour;
       src++;
      }/*for*/
      Total-=number;
     }/*if*/
     else
     if(number<224)
     {
      /* get the bitmap*/
      int m,num;
      m=0;
      num=number;


      for(k=0;k<256;k++)
      {
       if( (*src) & 0x80 )
       {
        x=k;
        y=x & 0xF;
        x=x>>4;
        Past[x + (y<<4)]=Colour;
        num--;
       }/*if*/
       (*src)<<=1;
       m++;
       if(m==8)
       {
        m=0;
        src++;
       }/*if*/
      }/*for*/

      if(num!=0)
       Msg("Error in the codification of the bitmap. Error: %i\n", num);

      Total-=number;
     }/*if*/
     else
     {
      int n;
      unsigned char *dest;

      dest=src;

      for(n=0;n<256;n++)
       if(n!=*src)
       {
        x=n;
        y=x & 0xF;
        x=x>>4;
        Past[x + (y<<4)]=Colour;
       }
       else
       if(((unsigned)(src-dest))<256-number-1)
       {
        src++;
       }
      src++;

      Total-=number;
     }/*else*/

     Colour=*src;
     Colour<<=8;
     src++;
     Colour|=*src;
     Colour<<=8;
     src++;
     Colour|=*src;
     src++;
     number=*src;
     src++;
    }/*while*/


 return src-sour;
}/*DireccionalInv*/
/*================================================================================*/
/* COMPRESSION FUNCTION */
static inline int Compress(unsigned char *src, unsigned char *dst, int width, int height)
{
 int i,j,w,h;
 unsigned k;
 int x,y,n,m;
 int len;
 unsigned char *dest;
 char founded=0;
 char zeroes=0;
 char eos=1; /* End Of Section*/
 unsigned char *Pointers[8];
 unsigned int Colours[256];
 unsigned int NCol[256];
 int ncolours=0;

 /* Initializes some variables */

 len=0;
 nsections=0;
 dest=dst;
 w=width/16;
 if(w*16!=width)
  w++;
 h=height/16;
 if(h*16!=height)
  h++;

if(enable_sections)
{
 /* Allocate Sections array */
 if((Sections=(unsigned int **)malloc(w*h*sizeof(int *))) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/
 for(i=0;i<w*h;i++)
  Sections[i]=NULL;
}//if



 for(i=0;i<8;i++)
  Pointers[i]=Section[i];

 /* Make the compression */
 for(i=0;i<h;i++)
  for(j=0;j<w;j++)
  {
   /* Take one section */
    /* Allocate memory */
if(enable_sections)
{
   if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
   {
    perror("Error allocating memory for one section\n");
    exit(1);
   }/*if*/
   for(x=0;x<16;x++)
    for(y=0;y<16;y++)
    {
     if( ((j*16+x)<width) && ((i*16+y)<height) )
     {
      Past[x + (y<<4)]=src[(j*16+x)*3 + (i*16+y)*width*3];
      Past[x + (y<<4)]<<=8;
      Past[x + (y<<4)]|=src[(j*16+x)*3 + (i*16+y)*width*3 + 1];
      Past[x + (y<<4)]<<=8;
      Past[x + (y<<4)]|=src[(j*16+x)*3 + (i*16+y)*width*3 + 2];
     }
     else
      Past[x + (y<<4)]=0;
    }/*for*/

   for(x=0;x<16;x++)
    for(y=0;y<16;y++)
     Actual[x][y]=Past[x + (y<<4)];
}//if
else
{
   for(x=0;x<16;x++)
    for(y=0;y<16;y++)
    {
     if( ((j*16+x)<width) && ((i*16+y)<height) )
     {
      Actual[x][y]=src[(j*16+x)*3 + (i*16+y)*width*3];
      Actual[x][y]<<=8;
      Actual[x][y]|=src[(j*16+x)*3 + (i*16+y)*width*3 + 1];
      Actual[x][y]<<=8;
      Actual[x][y]|=src[(j*16+x)*3 + (i*16+y)*width*3 + 2];
     }
     else
      Actual[x][y]=0;
    }/*for*/
}//else
    /* Compare with zero */
    zeroes=1;
    for(y=0;y<16;y++)
     for(x=0;x<16;x++)
      zeroes&=(Actual[x][y]==0);

    if(zeroes)
    {
      /*There is 256 zeroes!*/
      *dest=0x00; /*Put the code */
      dest++;
	  if(enable_sections)
       Sections[nsections++]=Past;
    }/*if*/
    else
    if(enable_sections)
    {
     /* Compare with anothers secctions */
     founded=0;
     if(nsections>0)
     {
      for(k=0;k<nsections && !founded;k++)
       if(Sections[k]!=NULL)
       {
        if(Equals(Past,Sections[k]))
        {
         *dest=0x03; /*Put the code */
         dest++;
         *Pointers[2]=((k+1)>>8) & 0xFF;
         Pointers[2]++;
         *Pointers[2]=(k+1) & 0xFF;
         Pointers[2]++;
         Sections[nsections]=NULL;
         nsections++;
         founded=1;
         free(Past);
        }/*if*/
       }/*if*/
     }/*if*/
    }/*else*/


   /* If not founded */
   if(!founded && !zeroes)
   {
    /* Put the Section*/
    if(enable_sections)
     Sections[nsections++]=Past;

    /* Make a histogram */
    ncolours=0;
    for(y=0;y<256;y++)
    {
     Colours[y]=0;
     NCol[y]=0;
    }/*for*/

    for(y=0;y<16;y++)
     for(x=0;x<16;x++)
      if(ncolours>0)
      {
       m=0;
       for(n=0;n<ncolours;n++)
        if(Actual[x][y]==Colours[n])
        {
         m=1;
         NCol[n]++;
        }/*if*/
       if(!m)
       {
        Colours[ncolours]=Actual[x][y];
        NCol[ncolours]=1;
        ncolours++;
       }/*if*/
      }/*if*/
      else
      {
       ncolours=1;
       Colours[0]=Actual[x][y];
       NCol[0]=1;
      }/*else*/

    if(ncolours==1)
    {
     m=0;

     if((NCol[m]==256) && (Colours[m]==0))
      Msg("Extrange error, previously undetected zero section\n");

     if((NCol[m]==256) && (Colours[m]!=0))
     {
      /*There is 256 colours*/
      *dest=0x01; /*Put the code */
      dest++;
      /*Put the colour in the 0 section */
      *Pointers[0]=(Colours[m]>>16) & 0xFF;
      Pointers[0]++;
      *Pointers[0]=(Colours[m]>>8) & 0xFF;
      Pointers[0]++;
      *Pointers[0]=Colours[m] & 0xFF;
      Pointers[0]++;
     }/*if*/
    }/*if*/

    if(ncolours==2)
    {
     m=0;
     for(n=0;n<ncolours;n++)
      if(NCol[n]==255)
      {
       m=n;
       break;
      }/*if*/

     if(NCol[m]==255)
     {
      /*There is 255 colours*/
      *dest=0x02; /*Put the code */
      dest++;
      /*Put the main colour in the 1 section */
      *Pointers[1]=(Colours[m]>>16) & 0xFF;
      Pointers[1]++;
      *Pointers[1]=(Colours[m]>>8) & 0xFF;
      Pointers[1]++;
      *Pointers[1]=Colours[m] & 0xFF;
      Pointers[1]++;
      /*Put the secondary colour in the 1 section */
      m=(m + 1) & 1;
      *Pointers[1]=(Colours[m]>>16) & 0xFF;
      Pointers[1]++;
      *Pointers[1]=(Colours[m]>>8) & 0xFF;
      Pointers[1]++;
      *Pointers[1]=Colours[m] & 0xFF;
      Pointers[1]++;
      /* Put the address of the secondary colour*/
      for(y=0;y<16;y++)
       for(x=0;x<16;x++)
        if(Actual[x][y]==Colours[m])
        {
         *Pointers[1]= (x << 4) | y;
         Pointers[1]++;
         break;
        }/*if*/

     }/*if*/
     else
     {
      /*There is 2 colours*/
      *dest=0x08; /*Put the code */
      dest++;
      /*Put the main colour in the 1 section */
      *Pointers[7]=(Colours[0]>>16) & 0xFF;
      Pointers[7]++;
      *Pointers[7]=(Colours[0]>>8) & 0xFF;
      Pointers[7]++;
      *Pointers[7]=Colours[0] & 0xFF;
      Pointers[7]++;
      /*Put the secondary colour in the 1 section */
      *Pointers[7]=(Colours[1]>>16) & 0xFF;
      Pointers[7]++;
      *Pointers[7]=(Colours[1]>>8) & 0xFF;
      Pointers[7]++;
      *Pointers[7]=Colours[1] & 0xFF;
      Pointers[7]++;

      /* Put the bitmap*/
      n=0;

      for(y=0;y<16;y++)
       for(x=0;x<16;x++)
       {
        *Pointers[7]<<=1;
        *Pointers[7]|=(Actual[x][y]==Colours[0]);
        n++;
        if(n==8)
        {
         Pointers[7]++;
         n=0;
        }/*if*/
       }/*for*/


     }/*else*/

    }/*if*/

    if(ncolours>127)
    {
     /* Can not compress so it is a raw section */
     *dest=0x07; /*Put the code */
     dest++;
     /* Put the information */
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
      {
       *Pointers[6]=(Actual[x][y]>>16) & 0xFF;
       Pointers[6]++;
       *Pointers[6]=(Actual[x][y]>>8) & 0xFF;
       Pointers[6]++;
       *Pointers[6]=Actual[x][y] & 0xFF;
       Pointers[6]++;
      }/*for*/
    }/*if*/

    if(ncolours>2 && ncolours<128)
    {
     /*Compress*/
     int Zero;
     m=0;

     for(n=0;n<ncolours;n++)
      if((NCol[n]>32) && (Colours[n]!=0))
       m++;

     Zero=0;
     for(n=0;n<ncolours;n++)
      if(Colours[n]==0)
       Zero=1;

     if(m>1 && !Zero)
     {
      /* There is 2 colours with more than 32 elements, so we eliminate a colour*/
      int A,B,C,Z,AxorB;
      A=0;
      for(n=0;n<ncolours;n++)
       if((NCol[n]>32))
       {
        A=n;
        break;
       }/*if*/
      B=0;
      for(n=0;n<ncolours;n++)
       if((NCol[n]>32) && (n!=A))
       {
        B=n;
        break;
       }/*if*/
      C=0;
      for(n=0;n<ncolours;n++)
       if((n!=A)&& (n!=B))
       {
        C=n;
        break;
       }/*if*/

      /*We have A,B,C selected*/
      Z=Colours[A]^Colours[B]^Colours[C];
      /*
       Pass 1:
        A^Z=B^C
        B^Z=A^C
        C^Z=A^B
        X^Z=X^Z

      */

     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
       Actual[x][y]^=Z;


     AxorB=Colours[A]^Colours[B];
     /*
      Pass 2:
       A^C^AxorB=B^C
       A^B^AxorB=0
     */
     *dest=0x04; /*Put the code */
     dest++;
     /* Put A*/
     *Pointers[3]=(Colours[A]>>16) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=(Colours[A]>>8) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=Colours[A] & 0xFF;
     Pointers[3]++;
     /* Put B*/
     *Pointers[3]=(Colours[B]>>16) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=(Colours[B]>>8) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=Colours[B] & 0xFF;
     Pointers[3]++;
     /* Put C*/
     *Pointers[3]=(Colours[C]>>16) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=(Colours[C]>>8) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=Colours[C] & 0xFF;
     Pointers[3]++;

     /* Put the Bitmap */
     n=0;
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
       if((Actual[x][y]==(Colours[A]^Colours[C])) || (Actual[x][y]==(Colours[A]^Colours[B])))
       {
        (*Pointers[3])<<=1;
        (*Pointers[3])|=1;
        Actual[x][y]^=AxorB;
        n++;
        if(n==8)
        {
         n=0;
         Pointers[3]++;
        }/*if*/
       }/*if*/
       else
       {
        (*Pointers[3])<<=1;
        n++;
        if(n==8)
        {
         n=0;
         Pointers[3]++;
        }/*if*/
       }/*else*/

      /* Put the normal directional compression */
      Z=Direccional(Pointers[3]);


      Pointers[3]+=Z;
      /*Put the End Of Section Symbol*/
      *Pointers[3]=0x00;
      Pointers[3]++;
      *Pointers[3]=0x00;
      Pointers[3]++;
      *Pointers[3]=0x00;
      Pointers[3]++;
      *Pointers[3]=0x00;
      Pointers[3]++;


     }/*if*/
     else
     if(Zero)
     {
      /* Normal compression with zero*/
      *dest=0x05; /*Put the code */
      dest++;
      /* Put the normal directional compression */
      n=Direccional(Pointers[4]);
      Pointers[4]+=n;
      /*Put the End Of Section Symbol*/
      *Pointers[4]=0x00;
      Pointers[4]++;
      *Pointers[4]=0x00;
      Pointers[4]++;
      *Pointers[4]=0x00;
      Pointers[4]++;
      *Pointers[4]=0x00;
      Pointers[4]++;

     }/*if*/
     else
     {
      /* Normal compression without zero*/
      *dest=0x06; /*Put the code */
      dest++;
      /* Put the normal directional compression */
      n=Direccional(Pointers[5]);
      Pointers[5]+=n;

     }/*else*/


    }/*if*/


   }/*if*/
  }/*for*/

  /* Put the sizes */
  for(i=0;i<7;i++)
  {
   *dest=((Pointers[i]-Section[i])>>24) & 0xFF;
   dest++;
   *dest=((Pointers[i]-Section[i])>>16) & 0xFF;
   dest++;
   *dest=((Pointers[i]-Section[i])>>8) & 0xFF;
   dest++;
   *dest=(Pointers[i]-Section[i]) & 0xFF;
   dest++;
  }/*for*/



  len=width*height*3;
  /* Put the content of each section */
  for(i=0;i<8;i++)
  {
   if( ((dest-dst)+(Pointers[i]-Section[i])) <= len )
   {
    memcpy(dest,Section[i],Pointers[i]-Section[i]);
    dest+=Pointers[i]-Section[i];
   }/*if*/
   else
   {
	Msg("Error: Image not compressed\n");
	len=-1;
   }/*else*/
  }/*for*/

  if(len!=-1)
   len=dest-dst;

if(enable_sections)
{
 for(i=0;i<w*h;i++)
  if(Sections[i]!=NULL)
   free(Sections[i]);

 free(Sections);
}//if



 return len;
}/*Compress*/

/*================================================================================*/
static inline void freeDecompress()
{
 unsigned k,j;

 for(k=0;k<nsections;k++)
  if(Sections[k]!=NULL)
  {
   free(Sections[k]);
   for(j=k+1;j<nsections;j++)
    if(Sections[j]==Sections[k])
     Sections[j]=NULL;
   Sections[k]=NULL;
  }/*if*/
}
/*================================================================================*/

/* DECOMPRESSION FUNCTION */
static inline void Decompress(unsigned char *src,unsigned char *dst,int len, int width, int height)
{
 int i,j,w,h, code, A,B,C,Z,AxorB;
 unsigned k;
 int x,y,n;
 unsigned char *sour, *aux;
 unsigned char *Section[8];
 unsigned int Colour;

 nsections=0;
 w=width/16;
 if(w*16!=width)
  w++;
 h=height/16;
 if(h*16!=height)
  h++;
 sour=src;

 Section[0]=src+w*h;
 for(i=1;i<8;i++)
 {
  Section[i]=(unsigned char*)(*Section[0] << 24);
  Section[0]++;
  Section[i]+=(*Section[0] << 16);
  Section[0]++;
  Section[i]+=(*Section[0] << 8);
  Section[0]++;
  Section[i]+= *Section[0];
  Section[0]++;
 }/*if*/



 for(i=1;i<8;i++)
  Section[i]+=(unsigned)Section[i-1];



 /* Allocate Sections array */
 if((Sections=(unsigned int **)malloc(w*h*sizeof(int *))) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/
 for(i=0;i<w*h;i++)
  Sections[i]=NULL;


 /*Start the decompression*/
 for(i=0;i<h;i++)
  for(j=0;j<w;j++)
  {
   code=*sour;
   sour++;
   switch(code)
   {
    case 0x00:
     /* 256 Zeroes */

     if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/

     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
      {
       Past[x + (y<<4)]=0;
      }/*for*/
     Sections[nsections++]=Past;

     break;
    case 0x01:
     /* 256 Colours equal to X */
     if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/
     Colour=(*Section[0]<<16);
     Section[0]++;
     Colour+=(*Section[0]<<8);
     Section[0]++;
     Colour+=*Section[0];
     Section[0]++;

     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
      {
       Past[x + (y<<4)]=Colour;
      }/*for*/


     Sections[nsections++]=Past;

     break;
    case 0x02:
     /* 255 Colours equals and 1 more */

     if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/
     Colour=(*Section[1]<<16);
     Section[1]++;
     Colour+=(*Section[1]<<8);
     Section[1]++;
     Colour+=*Section[1];
     Section[1]++;
     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
      {
       Past[x + (y<<4)]=Colour;
      }/*for*/

     Colour=(*Section[1]<<16);
     Section[1]++;
     Colour+=(*Section[1]<<8);
     Section[1]++;
     Colour+=*Section[1];
     Section[1]++;
     x=*Section[1];
     y=x & 0xF;
     x=x>>4;
     Section[1]++;
     Past[x + (y<<4)]=Colour;


     Sections[nsections++]=Past;
     break;
    case 0x03:
     /* Section equal to a previous one*/

     x=(*Section[2]<<8);
     Section[2]++;
     x+=*Section[2];
     Section[2]++;
     x--;

     Sections[nsections++]=Sections[x];
     break;
    case 0x04:
     /* With colour elimination */
     if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/

     A=(*Section[3]<<16);
     Section[3]++;
     A+=(*Section[3]<<8);
     Section[3]++;
     A+=*Section[3];
     Section[3]++;
     B=(*Section[3]<<16);
     Section[3]++;
     B+=(*Section[3]<<8);
     Section[3]++;
     B+=*Section[3];
     Section[3]++;
     C=(*Section[3]<<16);
     Section[3]++;
     C+=(*Section[3]<<8);
     Section[3]++;
     C+=*Section[3];
     Section[3]++;
     aux=Section[3];
     Section[3]+=32;

     n=DireccionalInv(Section[3]);
     Section[3]+=n;

     AxorB=A^B;

     n=0;
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
      {
       if(*aux & 0x80)
        Past[x + (y<<4)]^=AxorB;
       (*aux)<<=1;
       n++;
       if(n==8)
       {
        aux++;
        n=0;
       }/*if*/
      }/*for*/

     Z=A^B^C;
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
       Past[x + (y<<4)]^=Z;



     Sections[nsections++]=Past;

     break;
    case 0x05:
     /* With Zero */
     if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/



     n=DireccionalInv(Section[4]);
     Section[4]+=n;


     Sections[nsections++]=Past;
     break;
    case 0x06:
     /* Without Zero */
     if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/

     n=DireccionalInv(Section[5]);
     Section[5]+=n-4;



     Sections[nsections++]=Past;
     break;
    case 0x07:
     /* Raw Section */
     if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/

     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
      {
       Past[x + (y<<4)]=*Section[6];
       Past[x + (y<<4)]<<=8;
       Section[6]++;
       Past[x + (y<<4)]+=*Section[6];
       Past[x + (y<<4)]<<=8;
       Section[6]++;
       Past[x + (y<<4)]+=*Section[6];
       Section[6]++;

      }/*for*/



     Sections[nsections++]=Past;
     break;
    case 0x08:
     /* 2 colours section*/
     if((Past=(unsigned int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/
     A=(*Section[7]<<16);
     Section[7]++;
     A+=(*Section[7]<<8);
     Section[7]++;
     A+=*Section[7];
     Section[7]++;
     B=(*Section[7]<<16);
     Section[7]++;
     B+=(*Section[7]<<8);
     Section[7]++;
     B+=*Section[7];
     Section[7]++;

     n=0;
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
      {
       if(*Section[7] & 0x80)
        Past[x + (y<<4)]=A;
       else
        Past[x + (y<<4)]=B;
       (*Section[7])<<=1;
       n++;
       if(n==8)
       {
        Section[7]++;
        n=0;
       }/*if*/
      }/*for*/


     Sections[nsections++]=Past;
     break;
    default:
     Msg("Error: unknown code!\n");
	 freeDecompress();
	 return;
     break;
   }/*switch*/


  }/*for*/

 /* Paint the sections in the dst array*/
 k=0;
 for(i=0;i<h;i++)
  for(j=0;j<w;j++)
  {
   Past=Sections[k++];
   for(x=0;x<16;x++)
    for(y=0;y<16;y++)
    {
     if( ((j*16+x)<width) && ((i*16+y)<height) )
     {
      dst[(j*16+x)*3 + (i*16+y)*width*3]=(Past[x + (y<<4)]>>16) & 0xFF;
      dst[(j*16+x)*3 + (i*16+y)*width*3 + 1]=(Past[x + (y<<4)]>>8) & 0xFF;
      dst[(j*16+x)*3 + (i*16+y)*width*3 + 2]=Past[x + (y<<4)] & 0xFF;;

     }/*if*/
    }/*for*/
  }/*for*/

 /* Free the allocated resources */
 for(k=0;k<nsections;k++)
  if(Sections[k]!=NULL)
  {
   free(Sections[k]);
   for(j=(int)k+1;((unsigned)j)<nsections;j++)
    if(Sections[j]==Sections[k])
     Sections[j]=NULL;
   Sections[k]=NULL;
  }/*if*/

 free(Sections);
}/*Decompress*/



/********************************************************************
********************************************************************/
CodecInst::CodecInst() 
{ 
  int i;

  for(i=0;i<8;i++)
   Section[i]=NULL;

  yuy2_buffer=NULL;
  yuy2_buffer_old[0]=NULL;
  yuy2_buffer_old[1]=NULL;
  FrameCount=0;
  icinfo_sel=3;
  LastFrame=NULL;

}//CodecInst

/********************************************************************
********************************************************************/

void Msg(const char fmt[], ...) {
  static int debug = GetPrivateProfileInt("debug", "log", 0, "direccional.ini");
  if (!debug) return;

  DWORD written;
  char buf[2000];
  va_list val;
  
  va_start(val, fmt);
  wvsprintf(buf, fmt, val);

  const COORD _80x50 = {80,50};
  static BOOL startup = (AllocConsole(), SetConsoleScreenBufferSize(GetStdHandle(STD_OUTPUT_HANDLE), _80x50));
  WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), buf, lstrlen(buf), &written, 0);
}


int AppFlags() {
  static int flags = -1;
  if (flags < 0) {
    flags = 0;
    TCHAR apppath[MAX_PATH];
    if (GetModuleFileName(NULL, apppath, MAX_PATH)) {
      TCHAR* appname = strrchr(apppath, '\\');
      appname = appname ? appname+1 : apppath;
      Msg("App name is %s; ", appname);
      if (!lstrcmpi(appname, TEXT("premiere.exe")))
        flags = 1;
      if (!lstrcmpi(appname, TEXT("veditor.exe")))
        flags = 1;
      if (!lstrcmpi(appname, TEXT("afterfx.exe")))
        flags = 2;
      Msg("flags=%d\n", flags);
    }
  }
  return flags;
}


/********************************************************************
********************************************************************/

CodecInst* Open(ICOPEN* icinfo) {
  if (icinfo && icinfo->fccType != ICTYPE_VIDEO)
      return NULL;

  CodecInst* pinst = new CodecInst();

  if (icinfo) icinfo->dwError = pinst ? ICERR_OK : ICERR_MEMORY;

  return pinst;
}

DWORD Close(CodecInst* pinst) {
//    delete pinst;       // this caused problems when deleting at app close time
    return 1;
}

/********************************************************************
********************************************************************/

BOOL CodecInst::QueryAbout() { return TRUE; }

static BOOL CALLBACK AboutDialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  if (uMsg == WM_COMMAND) {
    switch (LOWORD(wParam)) {
    case IDOK:
      EndDialog(hwndDlg, 0);
      break;
    case IDC_HOMEPAGE:
      ShellExecute(NULL, NULL, "http://www.amacias.tk/", NULL, NULL, SW_SHOW);
      break;
    case IDC_EMAIL:
      ShellExecute(NULL, NULL, "mailto:amp_21004@yahoo.es", NULL, NULL, SW_SHOW);
      break;
    }
  }
  return FALSE;
}

DWORD CodecInst::About(HWND hwnd) {
  DialogBox(hmoduledireccional, MAKEINTRESOURCE(IDD_ABOUT), hwnd, AboutDialogProc);
  return ICERR_OK;
}

static BOOL CALLBACK ConfigureDialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  if (uMsg == WM_INITDIALOG) 
  {
    CheckDlgButton(hwndDlg, IDC_RGBOUTPUT,
      GetPrivateProfileInt("debug", "rgboutput", 0, "direccional.ini") ? BST_CHECKED : BST_UNCHECKED);
    CheckDlgButton(hwndDlg, IDC_LOG,
      GetPrivateProfileInt("debug", "log", 0, "direccional.ini") ? BST_CHECKED : BST_UNCHECKED);
    CheckDlgButton(hwndDlg, IDC_MOTION,
      GetPrivateProfileInt("debug", "motion", 0, "direccional.ini") ? BST_CHECKED : BST_UNCHECKED);
    CheckDlgButton(hwndDlg, IDC_INTERNAL,
      GetPrivateProfileInt("debug", "internal", 0, "direccional.ini") ? BST_CHECKED : BST_UNCHECKED);
    CheckDlgButton(hwndDlg, IDC_ENSURE,
      GetPrivateProfileInt("debug", "ensure", 0, "direccional.ini") ? BST_CHECKED : BST_UNCHECKED);
  } 
  else 
  if (uMsg == WM_COMMAND) 
  {
    switch (LOWORD(wParam)) 
	{
    case IDOK:
      WritePrivateProfileString("debug", "rgboutput",
        (IsDlgButtonChecked(hwndDlg, IDC_RGBOUTPUT) == BST_CHECKED) ? "1" : NULL, "direccional.ini");
      WritePrivateProfileString("debug", "log",
        (IsDlgButtonChecked(hwndDlg, IDC_LOG) == BST_CHECKED) ? "1" : "0", "direccional.ini");
      WritePrivateProfileString("debug", "motion",
        (IsDlgButtonChecked(hwndDlg, IDC_MOTION) == BST_CHECKED) ? "1" : "0", "direccional.ini");
      WritePrivateProfileString("debug", "internal",
        (IsDlgButtonChecked(hwndDlg, IDC_INTERNAL) == BST_CHECKED) ? "1" : "0", "direccional.ini");
      WritePrivateProfileString("debug", "ensure",
        (IsDlgButtonChecked(hwndDlg, IDC_ENSURE) == BST_CHECKED) ? "1" : "0", "direccional.ini");
    case IDCANCEL:
      EndDialog(hwndDlg, 0);
      break;
    default:
      return AboutDialogProc(hwndDlg, uMsg, wParam, lParam);    // handle email and home-page buttons
    }
  }

  return FALSE;
}

BOOL CodecInst::QueryConfigure() { return TRUE; }

DWORD CodecInst::Configure(HWND hwnd) {
  DialogBox(hmoduledireccional, MAKEINTRESOURCE(IDD_CONFIGURE), hwnd, ConfigureDialogProc);
  return ICERR_OK;
}


// we have no state information which needs to be stored

DWORD CodecInst::GetState(LPVOID pv, DWORD dwSize) { return 0; }

DWORD CodecInst::SetState(LPVOID pv, DWORD dwSize) { return 0; }


DWORD CodecInst::GetInfo(ICINFO* icinfo, DWORD dwSize) {
  if (icinfo == NULL)
    return sizeof(ICINFO);

  if (dwSize < sizeof(ICINFO))
    return 0;

  icinfo->dwSize            = sizeof(ICINFO);
  icinfo->fccType           = ICTYPE_VIDEO;
  icinfo->fccHandler        = FOURCC_HFYU;
  icinfo->dwFlags           = 0;

  icinfo->dwVersion         = VERSION;
  icinfo->dwVersionICM      = ICVERSION;
  MultiByteToWideChar(CP_ACP, 0, szDescription, -1, icinfo->szDescription, sizeof(icinfo->szDescription)/sizeof(WCHAR));
  MultiByteToWideChar(CP_ACP, 0, szName, -1, icinfo->szName, sizeof(icinfo->szName)/sizeof(WCHAR));

  return sizeof(ICINFO);
}


/********************************************************************
********************************************************************/


struct PrintBitmapType {
  char s[32];
  PrintBitmapType(LPBITMAPINFOHEADER lpbi) {
    if (!lpbi)
      strcpy(s,  "(null)");
    else {
      *(DWORD*)s = lpbi->biCompression;
      s[4] = 0;
      if (!isalnum(s[0]) || !isalnum(s[1]) || !isalnum(s[2]) || !isalnum(s[3]))
        wsprintfA(s, "%x", lpbi->biCompression);
      wsprintfA(strchr(s, 0), ", bits = %d", lpbi->biBitCount);
    }
  }
};


// fast clipping of values to unsigned char range

static unsigned char clip[896];

static void InitClip() {
  memset(clip, 0, 320);
  for (int i=0; i<256; ++i) clip[i+320] = i;
  memset(clip+320+256, 255, 320);
}

/*
static inline unsigned char Clip(int x)
  { return clip[320 + ((x+0x8000) >> 16)]; }
*/

#define Clip(x)  clip[320 + (((x)+0x8000) >> 16)]


/********************************************************************
********************************************************************/


// 0=unknown, -1=compressed YUY2, -2=compressed RGB, -3=compressed RGBA, 1=YUY2, 2=UYVY, 3=RGB 24-bit, 4=RGB 32-bit
static int GetBitmapType(LPBITMAPINFOHEADER lpbi) {
  if (!lpbi)
    return 0;
  if (lpbi->biCompression == FOURCC_VYUY || lpbi->biCompression == FOURCC_YUY2)
    return 1;
  if (lpbi->biCompression == FOURCC_UYVY)
    return 2;
  if (lpbi->biCompression == 0 || lpbi->biCompression == ' BID')
    return (lpbi->biBitCount == 24) ? 3 : (lpbi->biBitCount == 32) ? 4 : 0;
  if (lpbi->biCompression == FOURCC_HFYU)
    return (lpbi->biBitCount == 16) ? -1 : (lpbi->biBitCount == 24) ? -2 : (lpbi->biBitCount == 32) ? -3 : 0;
  return 0;
}


static bool CanCompress(LPBITMAPINFOHEADER lpbiIn) {
  int intype = GetBitmapType(lpbiIn);
  return (intype == 1 || intype == 2 || intype == 3 || (intype == 4 && (AppFlags()&2)));
}


static bool CanCompress(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {
  if (!lpbiOut) return CanCompress(lpbiIn);
  int outtype = GetBitmapType(lpbiOut);
  switch (GetBitmapType(lpbiIn)) {
    case 1: case 2:
      return (outtype == -1);
    case 3:
      return (outtype == 1 || outtype == -1 || outtype == -2);
    case 4:
      return (outtype == -3 && (AppFlags() & 2));
    default:
      return false;
  }
}


/********************************************************************
********************************************************************/


DWORD CodecInst::CompressQuery(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {
  Msg("CompressQuery: input = %s, output = %s\n", &PrintBitmapType(lpbiIn), &PrintBitmapType(lpbiOut));
  return CanCompress(lpbiIn, lpbiOut) ? ICERR_OK : ICERR_BADFORMAT;
}


DWORD CodecInst::CompressGetFormat(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {
  if (lpbiOut == 0)
    return sizeof(BITMAPINFOHEADER);

  if (!CanCompress(lpbiIn))
    return ICERR_BADFORMAT;

  bool compress_as_yuy2 = !!GetPrivateProfileInt("general", "compress_as_yuy2", false, "direccional.ini");

  *lpbiOut = *lpbiIn;
  lpbiOut->biCompression = FOURCC_HFYU;
  int intype = GetBitmapType(lpbiIn);
  lpbiOut->biBitCount = (intype==4) ? 32 : (intype==1 || intype==2 || compress_as_yuy2) ? 16 : 24;
  return ICERR_OK;
}


DWORD CodecInst::CompressBegin(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) 
{
//  total_bpp = 0;
//  num_frames = 0;
  int w,h;
  w=lpbiIn->biWidth/16;
  if(w*16!=lpbiIn->biWidth)
   w++;
  h=lpbiIn->biHeight/16;
  if(h*16!=lpbiIn->biHeight)
   h++;



  Msg("CompressBegin: input = %s, output = %s\n", &PrintBitmapType(lpbiIn), &PrintBitmapType(lpbiOut));

  CompressEnd();  // free resources if necessary

  enable_motion = !!GetPrivateProfileInt("debug", "motion", false, "direccional.ini");
  enable_internal = !!GetPrivateProfileInt("debug", "internal", false, "direccional.ini");

  enable_ensure = !!GetPrivateProfileInt("debug", "ensure", false, "direccional.ini");
  if(enable_ensure)
	  enable_motion=1;

  yuy2_buffer = new unsigned char[lpbiIn->biWidth * lpbiIn->biHeight * 3+1];

  yuy2_buffer_old[0] = new unsigned char[lpbiIn->biWidth * lpbiIn->biHeight * 3+1];
  yuy2_buffer_old[1] = new unsigned char[lpbiIn->biWidth * lpbiIn->biHeight * 3+1];

  if(enable_internal)
   LastFrame = new unsigned char[lpbiIn->biWidth * lpbiIn->biHeight * 3];


 /* Allocate Section 0 array, code=1, 256 elements = X*/
 if((Section[0]=(unsigned char *)malloc(w*h*3)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 1 array, code=2, 255 elements = X*/
 if((Section[1]=(unsigned char *)malloc(w*h*7)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 2 array, code=3, equal to a previous section*/
 if((Section[2]=(unsigned char *)malloc(w*h*2)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 3 array, code=4, Codification with color elimination*/
 if((Section[3]=(unsigned char *)malloc(w*h*768)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 4 array, code=5, Codification with 0 color*/
 if((Section[4]=(unsigned char *)malloc(w*h*768)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 5 array, code=6, Codification without 0 color*/
 if((Section[5]=(unsigned char *)malloc(w*h*768)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 6 array, code=7, RAW data*/
 if((Section[6]=(unsigned char *)malloc(w*h*768)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 7 array, code=8, 2 colours*/
 if((Section[7]=(unsigned char *)malloc(w*h*38)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/





  icinfo_sel=0;
  FrameCount=64;

  InitClip();

  return CanCompress(lpbiIn, lpbiOut) ? ICERR_OK : ICERR_BADFORMAT;
}

DWORD CodecInst::CompressGetSize(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {
  // Assume 24 bpp worst-case for YUY2 input, 40 bpp for RGB.
  // The actual worst case is 43/51 bpp currently, but this is exceedingly improbable
  // (probably impossible with real captured video)
  return lpbiIn->biWidth * lpbiIn->biHeight * ((GetBitmapType(lpbiIn) <= 2) ? 3 : 5);
}





DWORD CodecInst::Compress(ICCOMPRESS* icinfo, DWORD dwSize) 
{
  unsigned char* input = (unsigned char*)icinfo->lpInput;
  unsigned SizeImage=(icinfo->lpbiInput->biWidth * icinfo->lpbiInput->biHeight)*3;
  unsigned char* icinfo_ld=(unsigned char*)icinfo->lpPrev;
  unsigned i,j,k,l,m,n,o,p;
  unsigned char* output=(unsigned char*)icinfo->lpOutput;


 if(enable_internal)
  icinfo_ld=LastFrame;

 if(enable_motion)
 {
      unsigned EndLoop=SizeImage-8;

	  memcpy(yuy2_buffer,input,SizeImage);
	  input=yuy2_buffer;
      if((FrameCount==64) || (icinfo->dwFlags == ICCOMPRESS_KEYFRAME) || (icinfo_ld==NULL))
	  {
	   //insert a key frame every 64 frames
	   FrameCount=0;
       *icinfo->lpdwFlags = AVIIF_KEYFRAME;
       if(enable_internal)
	    memcpy(LastFrame,input,SizeImage);

	  }
	  else
	  {
       j=1;
	   k=2;
	   l=3;
	   m=4;
	   n=5;
	   o=6;
	   p=7;
	   // Substract the last frame from the actual
	   for(i=0; i<EndLoop;)
	   {
		  input[i] -= icinfo_ld[i];
		  i+=8;
		  input[j] -= icinfo_ld[j];
		  j+=8;
		  input[k] -= icinfo_ld[k];
		  k+=8;
		  input[l] -= icinfo_ld[l];
		  l+=8;
		  input[m] -= icinfo_ld[m];
		  m+=8;
		  input[n] -= icinfo_ld[n];
		  n+=8;
		  input[o] -= icinfo_ld[o];
		  o+=8;
		  input[p] -= icinfo_ld[p];
		  p+=8;
	   }//for
      }//else
      FrameCount++;
	  if(enable_internal)
	   memcpy(LastFrame,icinfo->lpInput,SizeImage);

 }//if
 else
 {
  *icinfo->lpdwFlags = AVIIF_KEYFRAME;
 }//else

  icinfo->lpbiOutput->biSizeImage = compress(input,output,icinfo->lpbiInput->biWidth,
	                                                      icinfo->lpbiInput->biHeight);


  if(enable_ensure && !(*icinfo->lpdwFlags == AVIIF_KEYFRAME))
  {
	  unsigned Size=compress((unsigned char*)icinfo->lpInput,input,icinfo->lpbiInput->biWidth,
	                                                  icinfo->lpbiInput->biHeight);
	  if(Size<icinfo->lpbiOutput->biSizeImage)
	  {
        icinfo->lpbiOutput->biSizeImage=Size;
		memcpy(output,input,Size);
        *icinfo->lpdwFlags = AVIIF_KEYFRAME;
		FrameCount=0;
	  }//if
  }//if


  if (icinfo->lpckid)
    *icinfo->lpckid = FOURCC_HFYU;


  return ICERR_OK;


}//Compress


inline void CodecInst::ConvertRGB24toYUY2(unsigned char* src, unsigned char* dst, int width, int height)
{
 unsigned char* rgb;
 unsigned char* yuv;
 int width3=width*3;
 int width2=width<<1;
 int y1,y2,scaled_y,b_y,r_y;
 


  for (int row = 0; row < height; ++row) 
  {
    rgb = src + width3 * (height-1-row);
    yuv = dst + width2 * row;
    for (int col = 0; col < width; col += 8) 
	{
      // y1 and y2 can't overflow
      yuv[0] = y1 = (cyb*rgb[0] + cyg*rgb[1] + cyr*rgb[2] + 0x108000) >> 16;
      yuv[2] = y2 = (cyb*rgb[3] + cyg*rgb[4] + cyr*rgb[5] + 0x108000) >> 16;
      scaled_y = (y1+y2 - 32) * int(255.0/219.0*32768+0.5);
      b_y = ((rgb[0]+rgb[3]) << 15) - scaled_y;
      r_y = ((rgb[2]+rgb[5]) << 15) - scaled_y;
      rgb += 6;
      yuv[1] = Clip((b_y >> 10) * int(1/2.018*1024+0.5) + 0x800000);  // u
      yuv[3] = Clip((r_y >> 10) * int(1/1.596*1024+0.5) + 0x800000);  // v
      yuv += 4;

      // y1 and y2 can't overflow
      yuv[0] = y1 = (cyb*rgb[0] + cyg*rgb[1] + cyr*rgb[2] + 0x108000) >> 16;
      yuv[2] = y2 = (cyb*rgb[3] + cyg*rgb[4] + cyr*rgb[5] + 0x108000) >> 16;
      scaled_y = (y1+y2 - 32) * int(255.0/219.0*32768+0.5);
      b_y = ((rgb[0]+rgb[3]) << 15) - scaled_y;
      r_y = ((rgb[2]+rgb[5]) << 15) - scaled_y;
      rgb += 6;
      yuv[1] = Clip((b_y >> 10) * int(1/2.018*1024+0.5) + 0x800000);  // u
      yuv[3] = Clip((r_y >> 10) * int(1/1.596*1024+0.5) + 0x800000);  // v
      yuv += 4;

      // y1 and y2 can't overflow
      yuv[0] = y1 = (cyb*rgb[0] + cyg*rgb[1] + cyr*rgb[2] + 0x108000) >> 16;
      yuv[2] = y2 = (cyb*rgb[3] + cyg*rgb[4] + cyr*rgb[5] + 0x108000) >> 16;
      scaled_y = (y1+y2 - 32) * int(255.0/219.0*32768+0.5);
      b_y = ((rgb[0]+rgb[3]) << 15) - scaled_y;
      r_y = ((rgb[2]+rgb[5]) << 15) - scaled_y;
      rgb += 6;
      yuv[1] = Clip((b_y >> 10) * int(1/2.018*1024+0.5) + 0x800000);  // u
      yuv[3] = Clip((r_y >> 10) * int(1/1.596*1024+0.5) + 0x800000);  // v
      yuv += 4;

      // y1 and y2 can't overflow
      yuv[0] = y1 = (cyb*rgb[0] + cyg*rgb[1] + cyr*rgb[2] + 0x108000) >> 16;
      yuv[2] = y2 = (cyb*rgb[3] + cyg*rgb[4] + cyr*rgb[5] + 0x108000) >> 16;
      scaled_y = (y1+y2 - 32) * int(255.0/219.0*32768+0.5);
      b_y = ((rgb[0]+rgb[3]) << 15) - scaled_y;
      r_y = ((rgb[2]+rgb[5]) << 15) - scaled_y;
      rgb += 6;
      yuv[1] = Clip((b_y >> 10) * int(1/2.018*1024+0.5) + 0x800000);  // u
      yuv[3] = Clip((r_y >> 10) * int(1/1.596*1024+0.5) + 0x800000);  // v
      yuv += 4;

    }
  }
}//ConvertRGB24toYUY2


DWORD CodecInst::CompressEnd() 
{
 int i;

 for(i=0;i<8;i++)
  if(Section[i])
  {
   free(Section[i]);
   Section[i]=NULL;
  }

  if (yuy2_buffer) 
  {
    delete[] yuy2_buffer;
    yuy2_buffer = 0;
  }//if

  if (LastFrame) 
  {
    delete[] LastFrame;
    LastFrame = 0;
  }//if


  if (yuy2_buffer_old[0]) 
  {
    delete[] yuy2_buffer_old[0];
    yuy2_buffer_old[0] = 0;
    delete[] yuy2_buffer_old[1];
    yuy2_buffer_old[1] = 0;
  }//if
  

  return ICERR_OK;
}//CompressEnd


/********************************************************************
********************************************************************/

static bool CanDecompress(LPBITMAPINFOHEADER lpbiIn) {
  int intype = GetBitmapType(lpbiIn);
  return (intype < 0 || intype == 1 || intype == 2);
}


static bool CanDecompress(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {
  if (!lpbiOut)
    return CanDecompress(lpbiIn);

  // must be 1:1 (no stretching)
  if (lpbiOut && (lpbiOut->biWidth != lpbiIn->biWidth || lpbiOut->biHeight != lpbiIn->biHeight))
    return false;

  int outtype = GetBitmapType(lpbiOut);
  switch (GetBitmapType(lpbiIn)) {
    case -1:
      // YUY2, RGB-24, RGB-32 output for compressed YUY2
      return (outtype == 1 || outtype == 3 || outtype == 4);
    case -2: case 1: case 2:
      // RGB-24, RGB-32 output only for YUY2/UYVY and compressed RGB
      return (outtype == 3 || outtype == 4);
    case -3:
      // RGB-32 output for compressed RGBA
      return (outtype == 4);
    default:
      return false;
  }
}

/********************************************************************
********************************************************************/


DWORD CodecInst::DecompressQuery(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {
  Msg("DecompressQuery: input = %s, output = %s\n", &PrintBitmapType(lpbiIn), &PrintBitmapType(lpbiOut));
  return CanDecompress(lpbiIn, lpbiOut) ? ICERR_OK : ICERR_BADFORMAT;
}


// This function should return "the output format which preserves the most
// information."  However, I now provide the option to return RGB format
// instead, since some programs treat the default format as the ONLY format.

DWORD CodecInst::DecompressGetFormat(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {

  // if lpbiOut == NULL, then return the size required to hold an output format struct
  if (lpbiOut == NULL)
    return lpbiIn->biSize;

  if (!CanDecompress(lpbiIn))
    return ICERR_BADFORMAT;

  // get default rgboutput value and allow the user to override
  bool rgboutput = AppFlags() & 1;
  rgboutput = !!GetPrivateProfileInt("debug", "rgboutput", rgboutput, "direccional.ini");

  memcpy(lpbiOut, lpbiIn, lpbiIn->biSize);

  int intype = GetBitmapType(lpbiIn);
  if (intype == -3) {
    lpbiOut->biBitCount = 32;   // "RGBA" (though not really)
    lpbiOut->biCompression = 0;
    lpbiOut->biSizeImage = lpbiIn->biWidth * lpbiIn->biHeight * 4;
  } else if (rgboutput || intype == -2 || intype == 1 || intype == 2) {
    lpbiOut->biBitCount = 24;   // RGB
    lpbiOut->biCompression = 0;
    lpbiOut->biSizeImage = lpbiIn->biWidth * lpbiIn->biHeight * 3;
  } else {
    lpbiOut->biBitCount = 16;       // YUY2
    lpbiOut->biCompression = FOURCC_YUY2;
    lpbiOut->biSizeImage = lpbiIn->biWidth * lpbiIn->biHeight * 2;
  }

  return ICERR_OK;
}

DWORD CodecInst::DecompressBegin(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {
  Msg("DecompressBegin: input = %s, output = %s\n", &PrintBitmapType(lpbiIn), &PrintBitmapType(lpbiOut));

  DecompressEnd();  // free resources if necessary

  // allocate buffer if decompressing HFYU->YUY2->RGB
  yuy2_buffer_old[0] = new unsigned char[lpbiIn->biWidth * lpbiIn->biHeight * 3+1];
  yuy2_buffer_old[1] = new unsigned char[lpbiIn->biWidth * lpbiIn->biHeight * 3+1];
  yuy2_buffer = new unsigned char[lpbiIn->biWidth * lpbiIn->biHeight * 3+1];
  icinfo_sel=0;

  InitClip();

  return CanDecompress(lpbiIn, lpbiOut) ? ICERR_OK : ICERR_BADFORMAT;
}




static inline void YUV2RGB(int y, int u, int v, BYTE* out) {
  const int crv = int(1.596*65536+0.5);
  const int cgv = int(0.813*65536+0.5);
  const int cgu = int(0.391*65536+0.5);
  const int cbu = int(2.018*65536+0.5);

  int scaled_y = (y - 16) * int((255.0/219.0)*65536+0.5);

  out[0] = Clip(scaled_y + (u-128) * cbu); // blue
  out[1] = Clip(scaled_y - (u-128) * cgu - (v-128) * cgv); // green
  out[2] = Clip(scaled_y + (v-128) * crv); // red
}


// I originally tried to do this with a template function, but it produced
// incorrect code.  So, since you insist...

#define ConvertYUVtoRGB(uyvy,rgb_bytes) \
  const int width = lpbiOutput->biWidth; \
  const int height = lpbiOutput->biHeight; \
  lpbiOutput->biSizeImage = width * height * rgb_bytes; \
\
  unsigned char* const yuv_base = (unsigned char*)src; \
  unsigned char* const rgb_base = (unsigned char*)dst; \
  for (int row = 0; row < height; ++row) { \
    unsigned char* yuv = yuv_base + width * 2 * (height-1-row); \
    unsigned char* rgb = rgb_base + width * rgb_bytes * row; \
    YUV2RGB(yuv[0+uyvy], yuv[1-uyvy], yuv[3-uyvy], rgb); \
    YUV2RGB(yuv[2+uyvy], yuv[1-uyvy], yuv[3-uyvy], rgb+rgb_bytes); \
    if (rgb_bytes==4) \
      rgb[7] = rgb[3] = 0; \
    for (int col = 2; col < width; col += 2) { \
      yuv += 4; \
      rgb += rgb_bytes*2; \
      /* interpolate chroma values */ \
      YUV2RGB(yuv[0+uyvy], (int(yuv[1-uyvy])+int(yuv[-3-uyvy]))/2, (int(yuv[3-uyvy])+int(yuv[-1-uyvy]))/2, rgb); \
      YUV2RGB(yuv[2+uyvy], yuv[1-uyvy], yuv[3-uyvy], rgb+rgb_bytes); \
      if (rgb_bytes==4) \
        rgb[7] = rgb[3] = 0; \
    } \
  } \
  return ICERR_OK


static DWORD ConvertYUY2toRGB24(LPBITMAPINFOHEADER lpbiOutput, void* src, void* dst) { ConvertYUVtoRGB(false,3); }
static DWORD ConvertYUY2toRGB32(LPBITMAPINFOHEADER lpbiOutput, void* src, void* dst) { ConvertYUVtoRGB(false,4); }
static DWORD ConvertUYVYtoRGB24(LPBITMAPINFOHEADER lpbiOutput, void* src, void* dst) { ConvertYUVtoRGB(true,3); }
static DWORD ConvertUYVYtoRGB32(LPBITMAPINFOHEADER lpbiOutput, void* src, void* dst) { ConvertYUVtoRGB(true,4); }


static inline void ConvertRGB24toRGB32(LPBITMAPINFOHEADER lpbiOutput, unsigned char *src) 
{ 
  const int width = lpbiOutput->biWidth; 
  const int height = lpbiOutput->biHeight; 
  lpbiOutput->biSizeImage = width * height * 4; 
  int i,j;

  j=width * height * 3 - 1;
  for(i=width * height * 4-1;i>0;i--)
   if( (i%4)!=3 )
    src[i]=src[j--];

}

DWORD CodecInst::Decompress(ICDECOMPRESS* icinfo, DWORD dwSize) 
{

  int width = icinfo->lpbiInput->biWidth;
  int height = icinfo->lpbiInput->biHeight;
  bool decompress_to_rgb = (icinfo->lpbiOutput->biBitCount > 16);
  unsigned char* icinfo_old2=yuy2_buffer;

  unsigned char* in = (unsigned char*)icinfo->lpInput;
  unsigned char* out= (unsigned char*)icinfo->lpOutput;


  int FrameSize=(width*height)*3;
  int SizeImage=icinfo->lpbiInput->biSizeImage;

  decompress(in, out, SizeImage, width,height);
      

      SizeImage=FrameSize;
	  // Add the last frame to the actual if it is not a key frame
	  if(icinfo->dwFlags & ICDECOMPRESS_NOTKEYFRAME)
	  {
	   for(int i=0; i<SizeImage; i++)
	 	  out[i] += icinfo_old2[i];
	  }

	  
	  memcpy(icinfo_old2,out,SizeImage);


      icinfo->lpbiOutput->biSizeImage=SizeImage;
	  if(icinfo->lpbiOutput->biBitCount == 32)
	   ConvertRGB24toRGB32(icinfo->lpbiOutput,out);

/*
  if (decompress_to_rgb) {
    if (icinfo->lpbiOutput->biBitCount == 32)
      ConvertYUY2toRGB32(icinfo->lpbiOutput, out, icinfo->lpOutput);
    else
      ConvertYUY2toRGB24(icinfo->lpbiOutput, out, icinfo->lpOutput);
  }
*/
  return ICERR_OK;
}



// palette-mapped output only
DWORD CodecInst::DecompressGetPalette(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut) {
  return ICERR_BADFORMAT;
}


DWORD CodecInst::DecompressEnd() 
{
  if (yuy2_buffer) 
  {
    delete[] yuy2_buffer;
    yuy2_buffer = 0;
  }//if

  if (yuy2_buffer_old[0]) 
  {
    delete[] yuy2_buffer_old[0];
    yuy2_buffer_old[0] = 0;
    delete[] yuy2_buffer_old[1];
    yuy2_buffer_old[1] = 0;
  }//if


 return ICERR_OK;
} // DecompressEnd

